<?php
namespace orm;

use gamboamartin\errores\errores;
use gamboamartin\orm\modelo;
use PDO;
use validacion\base\base_val_fiscal;


class modelo_nominas extends modelo { //PRUEBAS EN PROCESO

    public function __construct(PDO $link, string $tabla, array $columnas_extra = array(),
                                array $campos_obligatorios = array(), array $tipo_campos = array(),
                                array $columnas = array(), array $sub_querys = array(),
                                bool $aplica_transaccion_inactivo = true, bool $aplica_bitacora = false,
                                bool $aplica_seguridad = false, array $extension_estructura = array(),
                                array $renombres = array(), bool $validation = false)
    {
        parent::__construct($link, $tabla, $columnas_extra, $campos_obligatorios, $tipo_campos, $columnas,
            $sub_querys, $aplica_transaccion_inactivo, $aplica_bitacora, $aplica_seguridad, $extension_estructura,
            $renombres, $validation);

        $this->validacion = new base_val_fiscal();

    }

    public function elimina_bd(int $id): array{

        $valida = $this->validacion->valida_cambio_cfdi($this,$id);
        if(errores::$error){
            return $this->error->error('Error al validar cambio de cfdi',$valida);
        }

        $r_elimina = parent::elimina_bd($id); // TODO: Change the autogenerated stub
        if(errores::$error){
            return $this->error->error('Error al eliminar',$r_elimina);
        }

        return $r_elimina;
    }

    public function modifica_bd(array $registro, int $id, bool $reactiva = false):array{

        $valida = $this->validacion->valida_cambio_cfdi($this,$id);
        if(isset($valida['error'])){
            return $this->error->error('Error al validar cambio de cfdi',$valida);
        }

        $r_modifica_bd = parent::modifica_bd($registro, $id, $reactiva); // TODO: Change the autogenerated stub
        if(isset($r_modifica_bd['error'])){
            return $this->error->error('Error al modificar',$r_modifica_bd);
        }
        return $r_modifica_bd;
    }


}
